//
//  ViewController.m
//  UniPay
//
//  Created by zhong howard on 13-3-18.
//  Copyright (c) 2013年 __MyCompanyName__. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController
@synthesize resultsTextView;
@synthesize dataTextView;
@synthesize connectedLabel;
@synthesize txtAPDUData;
@synthesize txtDirectIO;

@synthesize sView;
@synthesize view1;
@synthesize view4;
@synthesize view5;
@synthesize pcControlPanes;
@synthesize prompt_doConnection;
@synthesize prompt_pickApp;


extern int g_IOS_Type;

-(void) appendMessageToResults:(NSString*) message{
    [self.resultsTextView setText:[NSString stringWithFormat:@"%@\n%@", self.resultsTextView.text, message]];
    [self.resultsTextView scrollRangeToVisible:NSMakeRange([self.resultsTextView.text length], 0)];
}

-(void) appendMessageToData:(NSString*) message{
    [self.dataTextView setText:[NSString stringWithFormat:@"%@\n%@", self.dataTextView.text, message]];
    [self.dataTextView scrollRangeToVisible:NSMakeRange([self.dataTextView.text length], 0)];
}

- (IBAction) DoClearLog:(id)sender{
    [self.resultsTextView setText: @""];
    [self.resultsTextView scrollRangeToVisible:NSMakeRange([self.resultsTextView.text length], 0)];
    [self.dataTextView setText: @""];
    [self.dataTextView scrollRangeToVisible:NSMakeRange([self.resultsTextView.text length], 0)];

}





//for return IDTResult type function
-(void) displayUpRet2:(NSString*) operation returnValue: (RETURN_CODE)rt
{
    
    NSString * str = [NSString stringWithFormat:
                      @"%@ ERROR: ID-\"%i\", message: %@.",
                      operation, rt, [[IDT_UniPay sharedController] device_getResponseCodeString:rt]];
    [self appendMessageToResults:str];
    
}

- (IBAction) DoKeyboardOff:(id)sender{
    [sender resignFirstResponder];
}


- (void)alertView:(UIAlertView *)alertView didDismissWithButtonIndex:(NSInteger)buttonIndex{
    if (alertView == prompt_pickApp) {
        if(buttonIndex == 1){
            UITextField *txtInput = [[alertView subviews] objectAtIndex:[[alertView subviews] count]-1];
            if ([txtInput isFirstResponder]) {
                [txtInput resignFirstResponder];
            }
            [[IDTechEMV sharedController] confirmApplication:[[txtInput text] intValue]];
        }else {
            [[IDTechEMV sharedController] confirmApplication:-1];
        }
    }
    
    if (alertView == prompt_doConnection)
    {
        //selected option to start the connection task at the reader attachment prompt
        if (1 == buttonIndex) {
            [self appendMessageToResults: @"Start Connect Task..."];
            [[IDT_UniPay sharedController] device_connectToAudioReader];
            
        }
    }

    
}




- (void)alertViewCancel:(UIAlertView *)alertView{
    if ([alertView.title isEqualToString:@"Please Select App Index #"]) {
        [[IDTechEMV sharedController] confirmApplication:-1];
    }
	
}

#pragma mark - UniPay Delegate methods

- (void) dataInOutMonitor:(NSData*)data  incoming:(BOOL)isIncoming{
    [self appendMessageToData:[NSString stringWithFormat:@"%@: %@",isIncoming?@"IN":@"OUT",data.description]];
}


- (void) plugStatusChange:(BOOL)deviceInserted{
    if (deviceInserted) {
        [self appendMessageToResults: @"device Attached."];
        [prompt_doConnection show];
    }
    else{
        [self appendMessageToResults: @"device removed."];
    }
}

-(void)deviceConnected{
    NSLog(@"Connected --");
    connectedLabel.text = @"Connected";
   [self appendMessageToResults:@"([UniPay sharedController] Connected)"];
}

-(void)deviceDisconnected{
    NSLog(@"DisConnt --");
    connectedLabel.text = @"Disconnect";
    [self appendMessageToResults:@"([UniPay sharedController] Disconnect)"];
}

- (void) swipeMSRData:(IDTMSRData*)cardData{
    NSLog(@"--MSR event Received, Type: %d, data: %@", cardData.event, cardData.encTrack1);
    switch (cardData.event) {
        case EVENT_MSR_CARD_DATA:
        {
            switch (cardData.captureEncodeType) {
                case CAPTURE_ENCODE_TYPE_ISOABA:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"ISO/ABA"]];
                    break;
                case CAPTURE_ENCODE_TYPE_AAMVA:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"AA/MVA"]];
                    break;

                case CAPTURE_ENCODE_TYPE_Other:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"Other"]];
                    break;

                case CAPTURE_ENCODE_TYPE_Raw:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"Raw"]];
                    break;

                default:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"UNKNOWN"]];

                    break;
            }
            
            [self appendMessageToResults:[NSString stringWithFormat:@"Full card data: %@", cardData.cardData]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Track 1: %@", cardData.track1]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Track 2: %@", cardData.track2]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Track 3: %@", cardData.track3]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Length Track 1: %i", cardData.track1Length]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Length Track 2: %i", cardData.track2Length]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Length Track 3: %i", cardData.track3Length]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Encoded Track 1: %@", cardData.encTrack1.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Encoded Track 2: %@", cardData.encTrack2.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Encoded Track 3: %@", cardData.encTrack3.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Hash Track 1: %@", cardData.hashTrack1.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Hash Track 2: %@", cardData.hashTrack2.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Hash Track 3: %@", cardData.hashTrack3.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"KSN: %@", cardData.KSN.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"\nSessionID: %@",  cardData.sessionID.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"\nReader Serial Number: %@",  cardData.RSN]];
            [self appendMessageToResults:[NSString stringWithFormat:@"\nRead Status: %2X",  cardData.readStatus]];

            NSLog(@"Track 1: %@", cardData.track1);
            NSLog(@"Track 2: %@", cardData.track2);
            NSLog(@"Track 3: %@", cardData.track3);
            NSLog(@"Encoded Track 1: %@", cardData.encTrack1.description);
            NSLog(@"Encoded Track 2: %@", cardData.encTrack2.description);
            NSLog(@"Encoded Track 3: %@", cardData.encTrack3.description);
            NSLog(@"Hash Track 1: %@", cardData.hashTrack1.description);
            NSLog(@"Hash Track 2: %@", cardData.hashTrack2.description);
            NSLog(@"Hash Track 3: %@", cardData.hashTrack3.description);
            NSLog(@"SessionID: %@", cardData.sessionID.description);
            NSLog(@"nReader Serial Number: %@", cardData.RSN);
            NSLog(@"Read Status: %2X", cardData.readStatus);
            NSLog(@"KSN: %@", cardData.KSN.description);

            return;
        }
            break;
            
        case EVENT_MSR_CANCEL_KEY:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR Cancel Key received: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        case EVENT_MSR_BACKSPACE_KEY:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR Backspace Key received: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        case EVENT_MSR_ENTER_KEY:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR Enter Key received: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        case EVENT_MSR_UNKNOWN:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR unknown event, data: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        default:
            break;
    }
}

-(void) eventFunctionICC: (Byte) nICC_Attached{
    NSLog(@"UniPay_EventFunctionICC Return Status Code %2X ",  nICC_Attached);
    [self appendMessageToResults:[NSString stringWithFormat:@"\nUniPay_EventFunctionICC Return Status Code %2X ",  nICC_Attached]];
    
}


- (void) confirmApplicationSelection:(NSArray*)labelArray{
    NSMutableString *str = [NSMutableString new];
    [str appendFormat:@"\n"];
    [str appendFormat:@"\n"];
    for (int x = 0; x < labelArray.count; x++) {
        [str appendFormat:@"%i: %@",x,[labelArray objectAtIndex:x]];
        if (x < labelArray.count-1) {
            [str appendFormat:@"\n"];
        }
    }
    
    NSLog(@"String description = %@",str.description);
    
    CGAffineTransform transform = CGAffineTransformMakeTranslation(0, 60);
    [prompt_pickApp setMessage:str.description];
	UITextField *textField = [[UITextField alloc] initWithFrame:CGRectMake(12, 45, 260, 25)];
    textField.backgroundColor = [UIColor whiteColor];
    textField.layer.cornerRadius = 5.0f;
    textField.keyboardType = UIKeyboardTypeNumberPad;
    
	[prompt_pickApp setTransform:transform];
	[prompt_pickApp addSubview:textField];
	[prompt_pickApp show];
    [textField becomeFirstResponder];
	//[alert release];
	//[textField release];
    textField = nil;
    

    
}



- (void) emvTransactionMessage:(MESSAGE_Types)message{
    switch (message) {
        case MESSAGE_INSERT_CARD:
            [self appendMessageToResults:@"PLEASE INSERT CARD"];
            break;
        case MESSAGE_REMOVE_CARD:
            [self appendMessageToResults:@"PLEASE REMOVE CARD"];
            break;
        default:
            break;
    }
}

-(void) dismissAllAlertViews {
    [prompt_doConnection dismissWithClickedButtonIndex:-1 animated:FALSE];
    [prompt_pickApp dismissWithClickedButtonIndex:-1 animated:FALSE];
}

- (void) emvTransactionData:(IDTEMVData*)emvData errorCode:(int)error performReversal:(BOOL)reversal{
    NSLog(@"Dictionary = %@",emvData.unencryptedTags.description);
    NSLog(@"Result code = %2X, Error Code %4X",emvData.resultCode,error);
    
    [self appendMessageToResults:[NSString stringWithFormat:@"Dictionary = %@",emvData.unencryptedTags.description]];
    [self appendMessageToResults:[NSString stringWithFormat:@"Result code = %2X, Error Code %4X",emvData.resultCode,error]];
    if (emvData.resultCode == 2) {
        [self appendMessageToResults:@"ONLINE REQUEST"];
    }
    if (emvData.resultCode == 2) {
        [self appendMessageToResults:@"SUCCESS"];
    }
    [self dismissAllAlertViews];
}





-(void) showAlertView:(NSString*)msg {
    [self dismissAllAlertViews];
    
    UIAlertView *alertView = [[UIAlertView alloc]
                              initWithTitle:@"uniMag"
                              message:msg
                              delegate:nil
                              cancelButtonTitle:@"Ok"
                              otherButtonTitles:nil];
    [alertView show];
    //[alertView release];
    alertView = nil;
}

#pragma mark - View methods

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    //init alert views
    prompt_doConnection = [[UIAlertView alloc]
                           initWithTitle:@"UniPay"
                           message:@"Device detected in headphone jack. Try connecting it?"
                           delegate:self
                           cancelButtonTitle:@"Cancel"
                           otherButtonTitles:@"OK",nil];
    
    prompt_pickApp = [[UIAlertView alloc] initWithTitle:@"Please Select App Index #" message:nil delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"OK",nil];


    
    
    //for iPhone
    if (0 == g_IOS_Type) {
        CGRect frame = self.sView.frame;
        frame.size.width = [UIScreen mainScreen].bounds.size.width;
        CGSize contentSize = frame.size;
        contentSize.width *= 3;
        self.sView.contentSize = contentSize;
        
        // add to scroll view
        frame.origin.y = 0;
        frame.origin.x = frame.size.width * 2   ;
        self.view5.frame = frame;
        [self.sView addSubview: self.view5];
        
        
        frame.origin.y = 0;
        frame.origin.x = frame.size.width * 1;
        self.view4.frame = frame;
        [self.sView addSubview: self.view4];
        
        frame.origin.y = 0;
        frame.origin.x = frame.size.width * 0;
        self.view1.frame = frame;
        [self.sView addSubview: self.view1];
        
        self.pcControlPanes.numberOfPages = 3;
        self.pcControlPanes.currentPage = 0;
    }

    
    //init object
#ifndef __i386__
    [IDT_UniPay sharedController].delegate = self;
    [IDTechEMV sharedController].delegate = self;
    [[IDT_UniPay sharedController] config_setCmdTimeOutDuration: 4];
#endif

}

- (void)viewDidUnload
{
     [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (void)scrollViewDidScroll:(UIScrollView *)sender {
    if (sender != self.sView)
        return;
    
    //for iPhone
    if (0 == g_IOS_Type) {
        //update UIPageControl object
        CGFloat pageWidth = self.sView.frame.size.width;
        int page = floor((self.sView.contentOffset.x + pageWidth / 2) / pageWidth);
        self.pcControlPanes.currentPage = page;
    }
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    NSLog(@"--viewDidAppear");
    BOOL b = [[IDT_UniPay sharedController] isConnected];
    if(b==YES)
    {
        [self deviceConnected];
        [self appendMessageToResults:@"[[UniPay sharedController] Open Success]"];
    }
    else
    {
        [self deviceDisconnected];
        [self appendMessageToResults:@"[[UniPay sharedController] Open Failed]"];
    }
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}


#pragma mark - spec methods
- (IBAction) f_getFirm:(id)sender
{    NSString *result;
    RETURN_CODE rt = [[IDT_UniPay sharedController]  device_getFirmwareVersion:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults: [NSString stringWithFormat:@"Get FM info:  %@", result]];
    }
    else{
        [self displayUpRet2: @"Get FM info" returnValue: rt];
    }
}

- (IBAction) f_DoTest:(id)sender
{
}

- (IBAction) f_getBatteryVoltage:(id)sender{
    NSString* result;
    RETURN_CODE rt = [[IDT_UniPay sharedController] device_getBatteryVoltage:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        
        [self appendMessageToResults: [NSString stringWithFormat:@"Battery Voltage:  %@", result]];
    }
    else{
        [self displayUpRet2: @"Battery Voltage" returnValue: rt];
    }
}


- (IBAction) f_getModelNumber:(id)sender
{
    

    NSString* result;
    RETURN_CODE rt = [[IDT_UniPay sharedController] config_getModelNumber:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        
        [self appendMessageToResults: [NSString stringWithFormat:@"Get ModelNumber:  %@", result]];
    }
    else{
        [self displayUpRet2: @"Get ModelNumber" returnValue: rt];
    }
    
}

- (IBAction) f_getSerialNumber:(id)sender
{
    NSString* result;
    RETURN_CODE rt = [[IDT_UniPay sharedController] config_getSerialNumber:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults: [NSString stringWithFormat:@"Get Serial Number:  %@", result]];
    }
    else{
        [self displayUpRet2: @"Get Serial Number" returnValue: rt];
    }
}
- (IBAction) f_setSerialNumber:(id)sender
{
    RETURN_CODE rt = [[IDT_UniPay sharedController] config_setSerialNumber:@"1234567890"];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults: [NSString stringWithFormat:@"Set Serial Number OK"]];
    }
    else{
        [self displayUpRet2: @"Get Serial Number" returnValue: rt];
    }
}






- (IBAction) f_iccNotifyON:(id)sender{
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_setICCNotification:true];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"f_iccNotifyON: OK."];
    }
    else{
        [self displayUpRet2: @"f_iccNotifyON" returnValue: rt];
    }
}
- (IBAction) f_iccNotifyOFF:(id)sender{
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_setICCNotification:false];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"f_iccNotifyOFF: OK."];
    }
    else{
        [self displayUpRet2: @"f_iccNotifyOFF" returnValue: rt];
    }
}




- (IBAction) f_RebootDevice:(id)sender{
    RETURN_CODE rt = [[IDT_UniPay sharedController] device_rebootDevice];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"RebootDevice: OK."];
    }
    else{
        [self displayUpRet2: @"RebootDevice" returnValue: rt];
    }
    
}

- (IBAction) f_DisableMSR:(id)sender{
    RETURN_CODE rt = [[IDT_UniPay sharedController] msr_cancelMSRSwipe];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"DisableMSR: OK."];
    }else
    {
        [self displayUpRet2: @"DisableMSR" returnValue:rt];
    }
}


- (IBAction) f_GetMSR_Format:(id)sender{
    NSString* response;
    RETURN_CODE rt = [[IDT_UniPay sharedController] msr_getSwipeEncryption:&response];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:[NSString stringWithFormat:@"GetMSR_dataFormat: %@", response]];
        if ([response isEqualToString:@"0"]) [self appendMessageToResults:@"Encrypted with Data Key"];
        if ([response isEqualToString:@"1"]) [self appendMessageToResults:@"Encrypted with PIN Key"];

    }else
    {
        [self displayUpRet2: @"GetMSR_dataFormat" returnValue: rt];
    }
    
}

- (IBAction) f_SetMSR_Format:(id)sender{
    RETURN_CODE rt = [[IDT_UniPay sharedController] msr_setSwipeEncryption:1];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"SetMSR_dataFormat: OK."];
    }else
    {
        [self displayUpRet2: @"SetMSR_dataFormat" returnValue: rt];
    }
}




- (IBAction) f_GetCardDataEncryption:(id)sender{
    NSString* response;
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_getKeyTypeForICCDUKPT:&response];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:[NSString stringWithFormat:@"GetCardDataEncryption: %@", response]];
        if ([response isEqualToString:@"1"]) [self appendMessageToResults:@"Encrypted with 3DES"];
        if ([response isEqualToString:@"2"]) [self appendMessageToResults:@"Encrypted with AES"];
        
    }else
    {
        [self displayUpRet2: @"GetCardDataEncryption" returnValue: rt];
    }
    
}

- (IBAction) f_SetCardDataEncryption:(id)sender{
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_setKeyFormatForICCDUKPT:2];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"SetCardDataEncryption: OK."];
    }else
    {
        [self displayUpRet2: @"SetCardDataEncryption" returnValue: rt];
    }
}


- (IBAction) f_EnableMSR_waitData: (id)sender{

    
    RETURN_CODE rt = [[IDT_UniPay sharedController] msr_startMSRSwipe:0];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"EnableMSR: OK."];
    }else
    {
        [self displayUpRet2: @"EnableMSR" returnValue:rt];
    }
}





- (IBAction) f_GetIccReaderStatus: (id)sender
{
    ICCReaderStatus* response;
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_getICCReaderStatus:&response];
    if(RETURN_CODE_DO_SUCCESS != rt){
        [self displayUpRet2: @"GetICCReaderStatus" returnValue: rt];
    }
    
        NSString *sta;
        if(response->iccPower)
            sta =@"[ICC Powered]";
        else
            sta = @"[ICC Power not Ready]";
        if(response->cardSeated)
            sta =[NSString stringWithFormat:@"%@,[Card Seated]", sta];
        else
            sta =[NSString stringWithFormat:@"%@,[Card not Seated]", sta];
        
        [self appendMessageToResults:[NSString stringWithFormat:@"%@",sta]];
    


}

- (IBAction) f_IccPowerON: (id)sender{
    NSData* response;
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_powerOnICC:&response];
    
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:[NSString stringWithFormat:@"ICC Powerd On, data: %@\n%@", response.description, [[NSString alloc] initWithData:response encoding:NSASCIIStringEncoding] ]];
        int lengthp = response.length;
        Byte * Response = (Byte*)[response bytes];
        if (0x90 == Response[lengthp-2])
        {
            [self appendMessageToResults:@" - Success."];
        }
        else
        {
            [self appendMessageToResults:@" - Failed."];
        }
    }else
    {
        [self displayUpRet2: @"ICC Powerd On" returnValue:rt];
    }
    
    return;
}

- (IBAction) f_IccPowerOFF: (id)sender{

    NSString* error;
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_powerOffICC:&error];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"ICC PowerOff: OK."];
    }else
    {
        [self displayUpRet2: @"ICC PowerOff" returnValue:rt];
    }
}

-(BOOL) isValidChar:(Byte)byChar{
    if ( ((byChar>(Byte)0x2F) && (byChar<(Byte)0x3A)) //'0' - '9'
        || ((byChar>(Byte)0x40) && (byChar<(Byte)0x47)) //'A' - 'F'
        || ((byChar>(Byte)0x60) && (byChar<(Byte)0x67)) //'a' - 'f'
        )
    {
        return YES;
    }
    return NO;
}


-(NSData*) hexStringToBytes:(NSString*)hexString{
    if (hexString.length<1) {
        return nil;
    }
    
    char tmpCh[1024] = {0};
    int count = 0;
    for (int k=0; k<hexString.length;k++) {
        char c = [hexString characterAtIndex:k];
        if (c == (char)0x20) {
            continue;
        }
        tmpCh[count] = c;
        count++;
    }
    tmpCh[count] = 0;
    
    if (count % 2) {
        return nil;
    }
    
    NSString *temp = [[NSString alloc] initWithUTF8String:tmpCh];
    int m = temp.length % 2;
    if (m>0) {
        return nil;
    }
    
    NSMutableData *result = [[NSMutableData alloc] init];
    unsigned char byte;
    char hexChars[3] = {0};
    for (int i=0; i < (temp.length/2); i++) {
        hexChars[0] = [temp characterAtIndex:i*2];
        hexChars[1] = [temp characterAtIndex:i*2+1];
        
        if (![self isValidChar:hexChars[0]] || ![self isValidChar:hexChars[1]]) {
            return nil;
        }
        byte = strtol(hexChars, NULL, 16);
        [result appendBytes:&byte length:1];
    }
    return [NSData dataWithData:result];
}

- (IBAction) f_DirectIO:(id)sender
{
    [txtDirectIO resignFirstResponder];
    
    NSData *dataBuffer = nil;
    NSString *valueEntered = txtDirectIO.text;
    if (valueEntered.length < 2)
    {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Invalid"
                                                        message:@"input data is invalid."
                                                       delegate:nil
                                              cancelButtonTitle:@"Dismiss"
                                              otherButtonTitles:nil];
        [alert show];
        return;
    }
    else
    {
        dataBuffer = [self hexStringToBytes:valueEntered];
        if (dataBuffer.length<1) {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Invalid"
                                                            message:@"input value is invalid."
                                                           delegate:nil
                                                  cancelButtonTitle:@"Dismiss"
                                                  otherButtonTitles:nil];
            [alert show];
            return;
        }
    }
    NSData* response;
    RETURN_CODE rt = [[IDT_UniPay sharedController] device_sendDataCommand:dataBuffer calcLRC:true response:&response];
    if (RETURN_CODE_DO_SUCCESS == rt) {
        [self appendMessageToResults:[NSString stringWithFormat:@"DirectIO Result: %@", response.description]];
        if (3 == response.length) {
            Byte *by1 = (unsigned char*)response.bytes;
            if ( (Byte)0x15 == by1[0]) {
                //RETURN_CODE rt2;
                NSData *nd = [NSData dataWithBytes: &by1[1] length:2];
                NSString *str = [[IDT_UniPay sharedController] device_getResponseCodeString:(((int)&by1[1]*256)+(int)&by1[2])];
                [self appendMessageToResults:[NSString stringWithFormat:@", errCode: %@, errInfo: %@", nd.description, str]];
            }
        }
    }
    else
    {
        [self displayUpRet2: @"DirectIO" returnValue:rt];
    }
}

- (IBAction) f_IccExchangeAPDU: (id)sender{
    [txtAPDUData resignFirstResponder];
    
    NSData *dataBuffer = nil;
    NSString *valueEntered = txtAPDUData.text;
    if (valueEntered.length < 6)
    {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Invalid"
                                                        message:@"input APDU data is invalid."
                                                       delegate:nil
                                              cancelButtonTitle:@"Dismiss"
                                              otherButtonTitles:nil];
        [alert show];
        return;
    }
    else
    {
        dataBuffer = [self hexStringToBytes:valueEntered];
        if (dataBuffer.length<3) {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Invalid"
                                                            message:@"input value is invalid."
                                                           delegate:nil
                                                  cancelButtonTitle:@"Dismiss"
                                                  otherButtonTitles:nil];
            [alert show];
            return;
        }
    }
    APDUResponse* response;
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_exchangeAPDU:dataBuffer encrypted:false response:&response];
    [self displayUpRet2: @"ExchangeAPDU" returnValue:rt];

    
    [self appendMessageToResults:[NSString stringWithFormat:@"ExchangeAPDU Result: Encrypted %@", response.hasEncryption?@"TRUE":@"FALSE" ]];
    [self appendMessageToResults:[NSString stringWithFormat:@"ExchangeAPDU Result: APDU %@", response.response.description ]];
    [self appendMessageToResults:[NSString stringWithFormat:@"ExchangeAPDU Result: Has KSN %@", response.hasKSN?@"TRUE":@"FALSE" ]];
    [self appendMessageToResults:[NSString stringWithFormat:@"ExchangeAPDU Result: KSN %@", response.ksn.description ]];


}


- (void) sendAPDU:(NSData*)cAPDU{
    APDUResponse* response;
    [[IDT_UniPay sharedController] icc_exchangeAPDU:cAPDU encrypted:false response:&response];
    if (response == nil) {
        return;
    }
}








-(IBAction) getTerminalFile:(id)sender{
    resultsTextView.text = @"";
    IDTech_TerminalData t = [[IDTechEMV sharedController] retrieveTerminalData];
    NSString* terminalCC = [NSString stringWithFormat:@"%4x",t.terminalCountryCode[0]*0x100+t.terminalCountryCode[1]];
    terminalCC = [terminalCC stringByReplacingOccurrencesOfString:@" " withString:@"0"];
    [self appendMessageToResults: [NSString stringWithFormat:@"Terminal Country Code = %@", terminalCC]];
    
    
    NSString* merchantCC = [NSString stringWithFormat:@"%4x",t.merchantCategoryCode[0]*0x100+t.merchantCategoryCode[1]];
    merchantCC = [merchantCC stringByReplacingOccurrencesOfString:@" " withString:@"0"];
    [self appendMessageToResults: [NSString stringWithFormat:@"Merchant Country Code = %@", merchantCC]];
    
    NSString* merchantID = [[NSString alloc] initWithBytes:&t.merchantID length:15 encoding:NSASCIIStringEncoding];
    [self appendMessageToResults: [NSString stringWithFormat:@"Merchant ID = %@", merchantID]];
    NSString* terminalID = [[NSString alloc] initWithBytes:&t.terminalID length:8 encoding:NSASCIIStringEncoding];
    [self appendMessageToResults: [NSString stringWithFormat:@"Terminal ID = %@", terminalID]];
    
    
    NSString* TACDefault = @"";
    
    TACDefault = [NSString stringWithFormat:@"%2x%2x%2x%2x%2x",t.defaultTACDefault[0],t.defaultTACDefault[1],t.defaultTACDefault[2],t.defaultTACDefault[3],t.defaultTACDefault[4]];
    TACDefault = [TACDefault stringByReplacingOccurrencesOfString:@" " withString:@"0"];
    [self appendMessageToResults: [NSString stringWithFormat:@"TAC Default = %@", TACDefault]];
    
    
    
    NSString* TACDenial = @"";
    TACDenial = [NSString stringWithFormat:@"%2x%2x%2x%2x%2x",t.defaultTACDenial[0],t.defaultTACDenial[1],t.defaultTACDenial[2],t.defaultTACDenial[3],t.defaultTACDenial[4]];
    TACDenial = [TACDenial stringByReplacingOccurrencesOfString:@" " withString:@"0"];
    [self appendMessageToResults: [NSString stringWithFormat:@"TAC Denial = %@", TACDenial]];
    
    
    NSString* TACOnline = @"";
    TACOnline = [NSString stringWithFormat:@"%2x%2x%2x%2x%2x",t.defaultTACOnline[0],t.defaultTACOnline[1],t.defaultTACOnline[2],t.defaultTACOnline[3],t.defaultTACOnline[4]];
    TACOnline = [TACOnline stringByReplacingOccurrencesOfString:@" " withString:@"0"];
    [self appendMessageToResults: [NSString stringWithFormat:@"TAC TACOnline = %@", TACOnline]];
    
    NSString* terminalLocation = [[NSString alloc] initWithBytes:&t.terminalLocation length:36 encoding:NSASCIIStringEncoding];
    [self appendMessageToResults: [NSString stringWithFormat:@"Terminal Location = %@", terminalLocation]];
    
}


-(IBAction)createTerminalFile:(id)sender{
    
    //UniPay
    IDTech_TerminalData t;
    t.terminalCountryCode[0] = 0x08;
    t.terminalCountryCode[1] = 0x40;
    t.merchantCategoryCode[0] = 0x12;
    t.merchantCategoryCode[1] = 0x34;
    t.merchantID[0] = 'I';
    t.merchantID[1] = 'D';
    t.merchantID[2] = ' ';
    t.merchantID[3] = 'T';
    t.merchantID[4] = 'E';
    t.merchantID[5] = 'C';
    t.merchantID[6] = 'H';
    t.merchantID[7] = ' ';
    t.merchantID[8] = 'R';
    t.merchantID[9] = '&';
    t.merchantID[10] = 'D';
    t.merchantID[11] = ' ';
    t.merchantID[12] = ' ';
    t.merchantID[13] = ' ';
    t.merchantID[14] = ' ';
    
    t.terminalID[0] = 0x38;
    t.terminalID[1] = 0x37;
    t.terminalID[2] = 0x36;
    t.terminalID[3] = 0x35;
    t.terminalID[4] = 0x34;
    t.terminalID[5] = 0x33;
    t.terminalID[6] = 0x32;
    t.terminalID[7] = 0x31;
    
    
    t.defaultTACDefault[0] = 0x00;
    t.defaultTACDefault[1] = 0x00;
    t.defaultTACDefault[2] = 0x80;
    t.defaultTACDefault[3] = 0x00;
    t.defaultTACDefault[4] = 0x00;
    t.defaultTACDenial[0] = 0x00;
    t.defaultTACDenial[1] = 0x00;
    t.defaultTACDenial[2] = 0x00;
    t.defaultTACDenial[3] = 0x00;
    t.defaultTACDenial[4] = 0x00;
    t.defaultTACOnline[0] = 0x00;
    t.defaultTACOnline[1] = 0x00;
    t.defaultTACOnline[2] = 0x00;
    t.defaultTACOnline[3] = 0x00;
    t.defaultTACOnline[4] = 0x00;
    
    t.useDefaultTACDefault = 0x00;
    t.useDefaultTACDenial = 0x00;
    t.useDefaultTACOnline = 0x00;
    
    t.terminalLocation[0] = '1';
    t.terminalLocation[1] = '0';
    t.terminalLocation[2] = '7';
    t.terminalLocation[3] = '2';
    t.terminalLocation[4] = '1';
    t.terminalLocation[5] = ' ';
    t.terminalLocation[6] = 'W';
    t.terminalLocation[7] = 'a';
    t.terminalLocation[8] = 'l';
    t.terminalLocation[9] = 'k';
    t.terminalLocation[10] = 'e';
    t.terminalLocation[11] = 'r';
    t.terminalLocation[12] = ' ';
    t.terminalLocation[13] = 'S';
    t.terminalLocation[14] = 't';
    t.terminalLocation[15] = '.';
    t.terminalLocation[16] = ' ';
    t.terminalLocation[17] = 'C';
    t.terminalLocation[18] = 'y';
    t.terminalLocation[19] = 'p';
    t.terminalLocation[20] = 'r';
    t.terminalLocation[21] = 'e';
    t.terminalLocation[22] = 's';
    t.terminalLocation[23] = 's';
    t.terminalLocation[24] = ',';
    t.terminalLocation[25] = ' ';
    t.terminalLocation[26] = 'C';
    t.terminalLocation[27] = 'A';
    t.terminalLocation[28] = ',';
    t.terminalLocation[29] = ' ';
    t.terminalLocation[30] = 'U';
    t.terminalLocation[31] = 'S';
    t.terminalLocation[32] = 'A';
    t.terminalLocation[33] = ' ';
    t.terminalLocation[34] = ' ';
    t.terminalLocation[35] = ' ';
    
    
    [[IDTechEMV sharedController] setTerminalData:t];
    resultsTextView.text = @"Terminal Settings Created";
    

}

-(IBAction) createAIDFile:(id)sender{

    
    
    IDTech_ApplicationID a;
    
    
    a.acquirerIdentifier[0] = 0x00;
    a.acquirerIdentifier[1] = 0x00;
    a.acquirerIdentifier[2] = 0x00;
    a.acquirerIdentifier[3] = 0x00;
    a.acquirerIdentifier[4] = 0x00;
    a.acquirerIdentifier[5] = 0x00;
    a.aid[0] = 0xa0;
    a.aid[1] = 0x00;
    a.aid[2] = 0x00;
    a.aid[3] = 0x00;
    a.aid[4] = 0x03;
    a.aid[5] = 0x10;
    a.aid[6] = 0x10;
    a.aid[7] = 0x00;
    a.aid[8] = 0x00;
    a.aid[9] = 0x00;
    a.aid[10] = 0x00;
    a.aid[11] = 0x00;
    a.aid[12] = 0x00;
    a.aid[13] = 0x00;
    a.aid[14] = 0x00;
    a.aid[15] = 0x00;
    a.aidLen = 0x07;
    a.applicationSelectionIndicator = 0x01;
    a.applicationVersionNumber[0] = 0x00;
    a.applicationVersionNumber[1] = 0x01;
    
    
    a.transactionCurrencyCode[0]=0x08;
    a.transactionCurrencyCode[1]=0x40;
    a.transactionCurrencyExponent = 0x02;
    a.tacDenial[0] = 0x00;
    a.tacDenial[1] = 0x00;
    a.tacDenial[2] = 0x00;
    a.tacDenial[3] = 0x00;
    a.tacDenial[4] = 0x00;
    a.useTACDenial = 0x00;
    
    a.tacDefault[0] = 0x00;
    a.tacDefault[1] = 0x00;
    a.tacDefault[2] = 0x00;
    a.tacDefault[3] = 0x00;
    a.tacDefault[4] = 0x00;
    a.useTACDefault = 0x00;
    
    a.tacOnline[0] = 0x00;
    a.tacOnline[1] = 0x00;
    a.tacOnline[2] = 0x00;
    a.tacOnline[3] = 0x00;
    a.tacOnline[4] = 0x00;
    a.useTACOnline = 0x00;
    
    [[IDTechEMV sharedController] setApplicationData:a];
    

    resultsTextView.text = @"AID for a0000000031010 created";
    

}
-(IBAction) getAIDFile:(id)sender{
    resultsTextView.text = @"";
    IDTech_ApplicationID t = [[IDTechEMV sharedController] retrieveApplicationData:@"a0000000031010"];
    if (t.aidLen == 0) {
        [self appendMessageToResults:@"AID File Not Returned - Try Again"];
        return;
    }
    
    [self appendMessageToResults:[[NSString stringWithFormat:@"CurrencyCode:%4x",t.transactionCurrencyCode[0]*0x100+t.transactionCurrencyCode[1]] stringByReplacingOccurrencesOfString:@" " withString:@"0"]];
    
    
    NSData* _aaid = [NSData dataWithBytes:&t.acquirerIdentifier length:6];
    NSString *aAquirerID = [[[[_aaid description] stringByReplacingOccurrencesOfString:@"<" withString:@""]
                             stringByReplacingOccurrencesOfString:@">" withString:@""]
                            stringByReplacingOccurrencesOfString:@" " withString:@""];
    [self appendMessageToResults:[NSString stringWithFormat:@"AquirerID: %@",aAquirerID]];
    
    NSData* _aid = [NSData dataWithBytes:&t.aid length:t.aidLen];
    NSString* aAID = [[[[_aid description] stringByReplacingOccurrencesOfString:@"<" withString:@""]
                       stringByReplacingOccurrencesOfString:@">" withString:@""]
                      stringByReplacingOccurrencesOfString:@" " withString:@""];
    [self appendMessageToResults:[NSString stringWithFormat:@"AID: %@",aAID]];
    
    NSString* aAIDVersion = [NSString stringWithFormat:@"%4x",t.applicationVersionNumber[0]*0x100+t.applicationVersionNumber[1]];
    aAIDVersion = [aAIDVersion stringByReplacingOccurrencesOfString:@" " withString:@"0"];
    [self appendMessageToResults:[NSString stringWithFormat:@"AID Version: %@",aAIDVersion]];
    
    NSString* aCurrencyExp = [NSString stringWithFormat:@"%2x",t.transactionCurrencyExponent];
    aCurrencyExp = [aCurrencyExp stringByReplacingOccurrencesOfString:@" " withString:@"0"];
    [self appendMessageToResults:[NSString stringWithFormat:@"Currency Exp: %@",aCurrencyExp]];
    
    
    NSData* _tac = [NSData dataWithBytes:&t.tacDenial length:5];
    NSString* aTACDenial = @"";
    aTACDenial = [[[[_tac description] stringByReplacingOccurrencesOfString:@"<" withString:@""]
                   stringByReplacingOccurrencesOfString:@">" withString:@""]
                  stringByReplacingOccurrencesOfString:@" " withString:@""];
    [self appendMessageToResults:[NSString stringWithFormat:@"TAC Denial: %@",aTACDenial]];
    
    NSData* _tacOnline = [NSData dataWithBytes:&t.tacOnline length:5];
    NSString* aTACOnline = @"";
    aTACOnline = [[[[_tacOnline description] stringByReplacingOccurrencesOfString:@"<" withString:@""]
                   stringByReplacingOccurrencesOfString:@">" withString:@""]
                  stringByReplacingOccurrencesOfString:@" " withString:@""];
    [self appendMessageToResults:[NSString stringWithFormat:@"TAC Online: %@",aTACOnline]];
    
    
    NSData* _tacDefault = [NSData dataWithBytes:&t.tacDefault length:5];
    NSString* aTACDefault = @"";
    aTACDefault = [[[[_tacDefault description] stringByReplacingOccurrencesOfString:@"<" withString:@""]
                    stringByReplacingOccurrencesOfString:@">" withString:@""]
                   stringByReplacingOccurrencesOfString:@" " withString:@""];
    [self appendMessageToResults:[NSString stringWithFormat:@"TAC Default: %@",aTACDefault]];
    
}
-(IBAction) removeAIDFile:(id)sender{
    [[IDTechEMV sharedController] removeApplicationData:@"a0000000031010"];
    [self appendMessageToResults:@"Removed AID a0000000031010"];
    
 
    
}
-(IBAction) getAIDFList:(id)sender{
    NSArray *dict =[[IDTechEMV sharedController] retrieveAIDList];

    NSLog(@"array = %@",dict.description);
    [self appendMessageToResults:[NSString stringWithFormat:@"array = %@", dict.description]];
}





-(IBAction)startEMV:(id)sender{

    resultsTextView.text = @"";
    NSMutableDictionary* tags;
    [[IDTechEMV sharedController] startEMVTransaction:2.95 timeout:30 transactionType:0 additionalTags:tags];

    
}

-(IBAction)completeEMV:(id)sender{
    
    resultsTextView.text = @"";
    NSMutableDictionary* dict = [NSMutableDictionary new];
    
    [dict setObject:[self hexToData:@"3030"] forKey:@"8a"];

    NSDictionary* myDict;
    myDict = nil;
    [[IDTechEMV sharedController]  completeOnlineEMVTransaction:EMV_COMPLETION_RESULT_ACCEPTED resultCode:@"00" issuerAuthenticationData:nil issuerScripts:nil];


    
}



-(unsigned int) char2hex:(char)c{
	
	switch (c) {
		case '0' ... '9': return c - '0';
		case 'a' ... 'f': return c - 'a' + 10;
		case 'A' ... 'F': return c - 'A' + 10;
		default: return -1;
	}
}

- (NSData *)hexToData:(NSString*)str {   //Example - Pass string that contains characters "30313233", and it will return a data object containing ascii characters "0123"
	if ([str length] == 0) {
		return nil;
	}
	
	unsigned stringIndex=0, resultIndex=0, max=(int)[str length];
	NSMutableData* result = [NSMutableData dataWithLength:(max + 1)/2];
	unsigned char* bytes = [result mutableBytes];
	
	unsigned num_nibbles = 0;
	unsigned char byte_value = 0;
	
	for (stringIndex = 0; stringIndex < max; stringIndex++) {
		unsigned int val = [self char2hex:[str characterAtIndex:stringIndex]];
		
		num_nibbles++;
		byte_value = byte_value * 16 + (unsigned char)val;
		if (! (num_nibbles % 2)) {
			bytes[resultIndex++] = byte_value;
			byte_value = 0;
		}
	}
	
	
	//final nibble
	if (num_nibbles % 2) {
		bytes[resultIndex++] = byte_value;
	}
	
	[result setLength:resultIndex];
	
	return result;
}

@end
